local idleCrackers,idleTimer,idleMax,title,w,h,font,menu,levelnum,gamemodelist,gamemodenum,winner,scorescore,previouscracker,player1control,player2control,player1select,player2select,player1char,player2char,player1num,player2num

function winUpdate(dt)
	if gamemode ~= "time rush" then
		for i,o in pairs(players) do
			if o.crackers >= winscore then
				gameEnd()
			end
		end
	else
		wintime = wintime - dt
		if wintime <= 0 then
			gameEnd()
		end
	end
end

function gameEnd()
winner = 0
scorescore = 0
for i,o in pairs(players) do
	if o.crackers > scorescore then
		scorescore = o.crackers
		winner = o.player
	end
end

game = false
menu = 4
idleMax = 0
end

local idleCrackers = {}

function menuStart(menumenu)
	gamemodelist = {
	"classic qwackers",
	"time rush",
	"golden cracker",
	--"king of the hill",
	"quack attack"
	}
	golden = 0
	goldtime = 0
	goldmax = 2
	previouscracker = true
	crackermove = true
	crackermovetime = 10
	levelnum = 0
	bouncy = false
	hydra = false
	hitboxes = false
	gamemodenum = 1
	gamemode = gamemodelist[gamemodenum]
	levelmode = "random"
	screenlist = {
		"wall",
		"loop",
		"space"	
	}
	screennum = 1
	screen = screenlist[screennum]
	griddraw = false
	effecteffect = true
	powerups = true
	wintime = 120
	friction = true
	winscore = 10
	speed = 1
	menu = menumenu
	game = false
	idleTimer = 0
	idleMax = 0.5
	title = love.graphics.newImage("title.png")
	w = title:getWidth()/2
	h = title:getHeight()
	title = newAnim(title,w,h,0.5)
	font = love.graphics.newFont("slkscr.ttf",30)
	winfont = love.graphics.newFont("slkscr.ttf",200)
	selectfont = love.graphics.newFont("slkscr.ttf",100)
	love.graphics.setFont(font)
	player1select = false
	player2select = false
	player1num = 1
	player2num = 1
	player1control = player1char[1]..player1char[2]..player1char[3]..player1char[4]..player1char[5]
	player2control = player2char[1]..player2char[2]..player2char[3]..player2char[4]..player2char[5]
end

player1char = {}
player2char = {}
player1char[1] = "w"
player1char[2] = "a"
player1char[3] = "s"
player1char[4] = "d"
player1char[5] = "f"
player2char[1] = "!"
player2char[2] = "@"
player2char[3] = "#"
player2char[4] = "$"
player2char[5] = "/"

function menuUpdate(dt)
	idleTimer = idleTimer - dt
	if idleTimer <= 0 then
		idleSpawn()
		idleTimer = idleMax
	end
	for i,o in pairs(idleCrackers) do
		o.y = o.y + o.speed * dt
		if o.type > 1 then
		else
			effectSpawn(o.x+o.w/2,o.y+o.h/2,o.type)
		end
		if o.y > 1080 then
			table.remove(idleCrackers,i)
		end
	end
	effectUpdate(dt)
	updateAnim(title,dt)
end

function menuDraw()
	effectDraw()
	for i,o in pairs(idleCrackers) do
		drawAnim(o.anim,o.x,o.y)
	end
	if not player1select then
		if not player2select then
			buttonDraw(menu)
			if menu == 1 then
				drawAnim(title,(1920-w)/2,20)
			end
		end
	end
	if player1select then
		selectDraw(1)
	elseif player2select then
		selectDraw(2)
	end
end

function idleSpawn()
	local w = 36
	local h = 27
	local x = math.random(0,1920-w)
	local y = 0-h
	local speed = math.random(100,300)
	local type = math.random(-1,14)
	table.insert(idleCrackers,{type=type,x=x,y=y,w=w,h=h,speed=speed,anim = newAnim(love.graphics.newImage("items/cracker.png"),w,h,0.2)})
end

function buttonDraw(menu)
	if menu == 1 then
		local text = {}
		local button = {}
		local off = {}
		text[1] = "START"
		text[2] = "OPTIONS"
		text[3] = "QUIT"
		local num = #text
		for x = 1,num do
			button[x] = love.graphics.newText(love.graphics.getFont(),text[x])
			off[x] = button[x]:getWidth()
		end
		love.graphics.setColor(0,0,0)
		for x = 1,num do
			love.graphics.rectangle("fill",(1920-500)/2,x*100-10+h,500,50)
		end
		love.graphics.setColor(1,1,1)
		for x = 1,num do
			love.graphics.print(text[x],(1920-off[x])/2,x*100+h)
			love.graphics.rectangle("line",(1920-500)/2,x*100-10+h,500,50)
		end
	elseif menu == 2 then
		local text = {}
		local button = {}
		local off = {}
		text[1] = "GAMEMODE: "..gamemode
		text[2] = "LEVEL: "..levelmode
		text[3] = "MODIFIERS"
		text[4] = "START"
		text[5] = "BACK"
		local num = #text
		for x = 1,num do
			button[x] = love.graphics.newText(love.graphics.getFont(),text[x])
			off[x] = button[x]:getWidth()
		end
		love.graphics.setColor(0,0,0)
		for x = 1,num do
			love.graphics.rectangle("fill",(1920-500)/2,x*100-10,500,50)
		end
		love.graphics.setColor(1,1,1)
		for x = 1,num do
			love.graphics.print(text[x],(1920-off[x])/2,x*100)
			love.graphics.rectangle("line",(1920-500)/2,x*100-10,500,50)
		end
	elseif menu == 3 then
		local text = {}
		local button = {}
		local off = {}
		text[1] = "HITBOXES: "..tostring(hitboxes)
		text[2] = "GAMESPEED: "..tostring(speed).."x"
		text[3] = "GRID: "..tostring(griddraw)
		text[4] = "PARTICLES: "..tostring(effecteffect)
		text[5] = "CHANGE PLAYER 1 CONTROLS"
		text[6] = "CHANGE PLAYER 2 CONTROLS"
		text[7] = "BACK"
		local num = #text
		for x = 1,num do
			button[x] = love.graphics.newText(love.graphics.getFont(),text[x])
			off[x] = button[x]:getWidth()
		end
		love.graphics.setColor(0,0,0)
		for x = 1,num do
			love.graphics.rectangle("fill",(1920-500)/2,x*100-10,500,50)
		end
		love.graphics.setColor(1,1,1)
		for x = 1,num do
			love.graphics.print(text[x],(1920-off[x])/2,x*100)
			love.graphics.rectangle("line",(1920-500)/2,x*100-10,500,50)
		end
	elseif menu == 4 then
		local x = 8
		local text = "BACK"
		local button = love.graphics.newText(winfont,"PLAYER "..winner.." WINS!")
		local off = button:getWidth()
		love.graphics.setFont(winfont)
		love.graphics.setColor(1,1,1)
		love.graphics.print("PLAYER "..winner.." WINS!",(1920-off)/2,100)
		love.graphics.setFont(font)
		button = love.graphics.newText(love.graphics.getFont(),text)
		off = button:getWidth()
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill",(1920-500)/2,x*100-10,500,50)
		love.graphics.setColor(1,1,1)
		love.graphics.print(text,(1920-off)/2,x*100)
		love.graphics.rectangle("line",(1920-500)/2,x*100-10,500,50)
	elseif menu == 5 then
		local text = {}
		local button = {}
		local off = {}
		if gamemode ~= "time rush" then
			text[1] = "SCORE TO WIN: "..tostring(winscore)
		else
			text[1] = "TIMER: "..tostring(wintime/60).." MINS"
		end
		text[2] = "BOUNCY WALLS: "..tostring(bouncy)
		text[3] = "HYDRA CRACKERS: "..tostring(hydra)
		text[4] = "POWERUPS: "..tostring(powerups)
		text[5] = "FRICTION: "..tostring(friction)
		text[6] = "SCREEN: "..tostring(screen)
		text[7] = "CRACKER RESPAWN: "..tostring(crackermove)
		text[8] = "CRACKER RESPAWN TIME: "..tostring(crackermovetime)
		text[9] = "RESET TO DEFAULT"
		text[10] = "BACK"
		local num = #text
		for x = 1,num do
			button[x] = love.graphics.newText(love.graphics.getFont(),text[x])
			off[x] = button[x]:getWidth()
		end
		love.graphics.setColor(0,0,0)
		for x = 1,num do
			love.graphics.rectangle("fill",(1920-500)/2,x*100-10,500,50)
		end
		love.graphics.setColor(1,1,1)
		for x = 1,num do
			love.graphics.print(text[x],(1920-off[x])/2,x*100)
			love.graphics.rectangle("line",(1920-500)/2,x*100-10,500,50)
		end
	end
end

function love.mousepressed(mousex,mousey)
	if not player1select then
		if not player2select then
			if menu == 1 then
				local x = 1
				if menuCollision((1920-500)/2,x*100-10+h,500,50,mousex,mousey,1,1) then
					menu = 2
				end
				local x = 2
				if menuCollision((1920-500)/2,x*100-10+h,500,50,mousex,mousey,1,1) then
					menu = 3
				end
				local x = 3
				if menuCollision((1920-500)/2,x*100-10+h,500,50,mousex,mousey,1,1) then
					love.event.quit()
				end
			elseif menu == 2 then
				local x = 1
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					gamemodenum = gamemodenum + 1
					if gamemodenum > #gamemodelist then
						gamemodenum = 1
					end
					gamemode = gamemodelist[gamemodenum]
					if gamemode == "golden cracker" then
						crackermove = false
					else
						crackermove = previouscracker
					end
				end
				local x = 2
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					levelnum = levelnum + 1
					if levelnum > #randomLevels then
						levelnum = 0
					end
					if levelnum == 0 then
						levelmode = "random"
					else
						levelmode = randomLevels[levelnum]
					end
				end
				local x = 3
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					menu = 5
				end
				local x = 4
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					game = true
					gameStart(levelmode,speed,player1control,player2control)
				end
				local x = 5
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					menu = 1
				end
			elseif menu == 3 then
				local x = 1
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					hitboxes = not hitboxes
				end
				local x = 2
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					speed = speed +1
					if speed > 5 then
						speed = 1
					end
				end
				local x = 3
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					griddraw = not griddraw
				end
				local x = 4
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					effecteffect = not effecteffect
				end
				local x = 5
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					player1select = true
				end
				local x = 6
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					player2select = true
				end
				local x = 7
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					menu = 1
				end
			elseif menu == 4 then
				local x = 8
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					menuStart(1)
				end
			elseif menu == 5 then
				local x = 1
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					if gamemode ~= "time rush" then
						winscore = winscore *2
						if winscore == 20 then
							winscore = 25
						end
						if winscore > 200 then
							winscore = 5
						end
					else
						if wintime == 30 then
							wintime = 60
						else
							wintime = wintime + 60
						end
						if wintime > 300 then
							wintime = 30
						end
					end
				end
				local x = 2
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					bouncy = not bouncy
				end
				local x = 3
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					hydra = not hydra
				end
				local x = 4
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					powerups = not powerups
				end
				local x = 5
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					friction = not friction
				end
				local x = 6
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					screennum = screennum + 1
					if screennum > #screenlist then
						screennum = 1
					end
					screen = screenlist[screennum]
				end
				local x = 7
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					crackermove = not crackermove
					previouscracker = crackermove
				end
				local x = 8
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					crackermovetime = crackermovetime*2
					if crackermovetime >20 then
						crackermovetime = 1
					end
					if crackermovetime == 4 then
						crackermovetime = 5
					end
				end
				local x = 9
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					menuStart(menu)
				end
				local x = 10
				if menuCollision((1920-500)/2,x*100-10,500,50,mousex,mousey,1,1) then
					menu = 2
				end
			end
		end
	end
end

function love.keypressed(key)
	if string.len(key) == 1 then
		if player1select then
			player1char[player1num] = key
			player1num = player1num + 1
			if player1num > 5 then
				menuStart(3)
			end
		elseif player2select then
			player2char[player2num] = key
			player2num = player2num + 1
			if player2num > 5 then
				menuStart(3)
			end
		end
	elseif key == "up" then
		if player1select then
			player1char[player1num] = "!"
			player1num = player1num + 1
			if player1num > 5 then
				menuStart(3)
			end
		elseif player2select then
			player2char[player2num] = "!"
			player2num = player2num + 1
			if player2num > 5 then
				menuStart(3)
			end
		end
	elseif key == "left" then
		if player1select then
			player1char[player1num] = "@"
			player1num = player1num + 1
			if player1num > 5 then
				menuStart(3)
			end
		elseif player2select then
			player2char[player2num] = "@"
			player2num = player2num + 1
			if player2num > 5 then
				menuStart(3)
			end
		end
	elseif key == "down" then
		if player1select then
			player1char[player1num] = "#"
			player1num = player1num + 1
			if player1num > 5 then
				menuStart(3)
			end
		elseif player2select then
			player2char[player2num] = "#"
			player2num = player2num + 1
			if player2num > 5 then
				menuStart(3)
			end
		end
	elseif key == "right" then
		if player1select then
			player1char[player1num] = "$"
			player1num = player1num + 1
			if player1num > 5 then
				menuStart(3)
			end
		elseif player2select then
			player2char[player2num] = "$"
			player2num = player2num + 1
			if player2num > 5 then
				menuStart(3)
			end
		end
	end
	if key == "escape" then
		menuStart(1)
		game = false
	end
end

function selectDraw(player)
love.graphics.setFont(selectfont)
if player == 1 then
	for x = 1,5 do
		if player1char[x] == "!" then
			player1char[x] = "up"
		elseif player1char[x] == "@" then
			player1char[x] = "left"
		elseif player1char[x] == "#" then
			player1char[x] = "down"
		elseif player1char[x] == "$" then
			player1char[x] = "right"
		end
	end
	if player1num == 1 then
		local button = love.graphics.newText(love.graphics.getFont(),"PRESS YOUR BUTTON TO GO UP")
		local off = button:getWidth()
		love.graphics.print("PRESS YOUR BUTTON TO GO UP",(1920-off)/2,10)
		button = love.graphics.newText(love.graphics.getFont(),"CURRENTLY "..player1char[1])
		off = button:getWidth()
		love.graphics.print("CURRENTLY "..player1char[1],(1920-off)/2,200)
	elseif player1num == 2 then
		local button = love.graphics.newText(love.graphics.getFont(),"PRESS YOUR BUTTON TO GO LEFT")
		local off = button:getWidth()
		love.graphics.print("PRESS YOUR BUTTON TO GO LEFT",(1920-off)/2,10)
		button = love.graphics.newText(love.graphics.getFont(),"CURRENTLY "..player1char[2])
		off = button:getWidth()
		love.graphics.print("CURRENTLY "..player1char[2],(1920-off)/2,200)
	elseif player1num == 3 then
		local button = love.graphics.newText(love.graphics.getFont(),"PRESS YOUR BUTTON TO GO DOWN")
		local off = button:getWidth()
		love.graphics.print("PRESS YOUR BUTTON TO GO DOWN",(1920-off)/2,10)
		button = love.graphics.newText(love.graphics.getFont(),"CURRENTLY "..player1char[3])
		off = button:getWidth()
		love.graphics.print("CURRENTLY "..player1char[3],(1920-off)/2,200)
	elseif player1num == 4 then
		local button = love.graphics.newText(love.graphics.getFont(),"PRESS YOUR BUTTON TO GO RIGHT")
		local off = button:getWidth()
		love.graphics.print("PRESS YOUR BUTTON TO GO RIGHT",(1920-off)/2,10)
		button = love.graphics.newText(love.graphics.getFont(),"CURRENTLY "..player1char[4])
		off = button:getWidth()
		love.graphics.print("CURRENTLY "..player1char[4],(1920-off)/2,200)
	elseif player1num == 5 then
		local button = love.graphics.newText(love.graphics.getFont(),"PRESS YOUR BUTTON TO QUACK")
		local off = button:getWidth()
		love.graphics.print("PRESS YOUR BUTTON TO QUACK",(1920-off)/2,10)
		button = love.graphics.newText(love.graphics.getFont(),"CURRENTLY "..player1char[5])
		off = button:getWidth()
		love.graphics.print("CURRENTLY "..player1char[5],(1920-off)/2,200)
	end
	for x = 1,5 do
		if player1char[x] == "up" then
			player1char[x] = "!"
		elseif player1char[x] == "left" then
			player1char[x] = "@"
		elseif player1char[x] == "down" then
			player1char[x] = "#"
		elseif player1char[x] == "right" then
			player1char[x] = "$"
		end
	end
end
if player == 2 then
	for x = 1,5 do
		if player2char[x] == "!" then
			player2char[x] = "up"
		elseif player2char[x] == "@" then
			player2char[x] = "left"
		elseif player2char[x] == "#" then
			player2char[x] = "down"
		elseif player2char[x] == "$" then
			player2char[x] = "right"
		end
	end
	if player2num == 1 then
		local button = love.graphics.newText(love.graphics.getFont(),"PRESS YOUR BUTTON TO GO UP")
		local off = button:getWidth()
		love.graphics.print("PRESS YOUR BUTTON TO GO UP",(1920-off)/2,10)
		button = love.graphics.newText(love.graphics.getFont(),"CURRENTLY "..player2char[1])
		off = button:getWidth()
		love.graphics.print("CURRENTLY "..player2char[1],(1920-off)/2,200)
	elseif player2num == 2 then
		local button = love.graphics.newText(love.graphics.getFont(),"PRESS YOUR BUTTON TO GO LEFT")
		local off = button:getWidth()
		love.graphics.print("PRESS YOUR BUTTON TO GO LEFT",(1920-off)/2,10)
		button = love.graphics.newText(love.graphics.getFont(),"CURRENTLY "..player2char[2])
		off = button:getWidth()
		love.graphics.print("CURRENTLY "..player2char[2],(1920-off)/2,200)
	elseif player2num == 3 then
		local button = love.graphics.newText(love.graphics.getFont(),"PRESS YOUR BUTTON TO GO DOWN")
		local off = button:getWidth()
		love.graphics.print("PRESS YOUR BUTTON TO GO DOWN",(1920-off)/2,10)
		button = love.graphics.newText(love.graphics.getFont(),"CURRENTLY "..player2char[3])
		off = button:getWidth()
		love.graphics.print("CURRENTLY "..player2char[3],(1920-off)/2,200)
	elseif player2num == 4 then
		local button = love.graphics.newText(love.graphics.getFont(),"PRESS YOUR BUTTON TO GO RIGHT")
		local off = button:getWidth()
		love.graphics.print("PRESS YOUR BUTTON TO GO RIGHT",(1920-off)/2,10)
		button = love.graphics.newText(love.graphics.getFont(),"CURRENTLY "..player2char[4])
		off = button:getWidth()
		love.graphics.print("CURRENTLY "..player2char[4],(1920-off)/2,200)
	elseif player2num == 5 then
		local button = love.graphics.newText(love.graphics.getFont(),"PRESS YOUR BUTTON TO QUACK")
		local off = button:getWidth()
		love.graphics.print("PRESS YOUR BUTTON TO QUACK",(1920-off)/2,10)
		button = love.graphics.newText(love.graphics.getFont(),"CURRENTLY "..player2char[5])
		off = button:getWidth()
		love.graphics.print("CURRENTLY "..player2char[5],(1920-off)/2,200)
	end
	for x = 1,5 do
		if player2char[x] == "up" then
			player2char[x] = "!"
		elseif player2char[x] == "left" then
			player2char[x] = "@"
		elseif player2char[x] == "down" then
			player2char[x] = "#"
		elseif player2char[x] == "right" then
			player2char[x] = "$"
		end
	end
end
end